#
# shinGETsu - P2P anonymous BBS
#
# (c) FukTommy <fuktommy@users.sourceforge.net>
# Released under the GNU General Public License
# $Id: Extern.pm.command,v 1.2 2004/02/25 14:47:22 fuktommy Exp $
#

package Shingetsu::Extern;
use IPC::Open2;
use Shingetsu::Config;

#
# pipe command
#
sub command($@) {
	my($command, @input) = @_;
	local $SIG{CHLD} = "DEFAULT";
	open2 IN, OUT, "$command" or die "$command: exec faild. $!";
	binmode IN; binmode OUT;
	local $_;
	if (fork == 0) {
		close IN;
		print OUT @input;
		close OUT;
		exit;
	}
	close OUT;
	my @buf = ();
	while (<IN>) {
		push @buf, $_;
	}
	close IN;
	wait; wait;
	return @buf;
}


#
# mime base-64 encode
#
sub base64encode($) {
	my @buf = command("$Shingetsu::Config::command{uuencode} null", @_);
	$_ = shift @buf;
	if ($_ !~ /^begin-base64/) {
		die "$uuencode: wrong output.";
	}
	pop @buf;
	chomp @buf;
	return join "", @buf;
}

#
# mime base-64 decode
#
sub base64decode($) {
	my($input) = @_;
	my @input = ("begin-base64 644 -\n");

	my $l = length $input;
	for ($i=0; $i<$l; $i+=60) {
		push @input, substr($input, $i, 60) . "\n";
	}
	push @input, "====\n";
	my @buf = command($Shingetsu::Config::command{uudecode}, @input);
	return join "", @buf;
}

#
# md5 message-digest
#
sub md5digest($) {
	my @buf = command($Shingetsu::Config::command{md5sum}, @_);
	return substr $buf[0], 0, 32;
}

#
# gzip
#
sub xgzip($) {
	my @buf = command($Shingetsu::Config::command{gzip}, @_);
	return join "", @buf;
}

#
# gunzip
#
sub xgunzip(@) {
	return command($Shingetsu::Config::command{gunzip}, @_);
}

1;
